/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"
#include "MonochromeLib.h"
#include "time.h"
#include "ECode.h"

#define HEIGHT 20
#define WIDTH 40
#define MAX 1000

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int key, i, j, x, y, k, l;
	unsigned char map[HEIGHT*WIDTH];
	unsigned char chemin[MAX][2];
	unsigned char haut, bas, gauche, droite, choix, dead;
	unsigned int index = 1;
	
	for(i=0; i< HEIGHT; i++)
		for(j=0;j<WIDTH; j++)
			{
			map[HEIGHT*i + j] = 1;
			ML_pixel(j,i,1);
			}
		srand(RTC_GetTicks());
	
	x = 0;
	k = 0;
	
	y = 0;
	l = 0;

	chemin[1][0] = 0;
	chemin[1][1] = 0;

	ML_pixel(0,0,0);
	while(index)
	{
		haut = 0;
		bas = 0;
		gauche = 0;
		droite = 0;
		
		if(x>1 && map[y*HEIGHT + x-2] == 1)
			gauche++;
		if(x<WIDTH-2 && map[y*HEIGHT + x+2] == 1)
			droite++;
		if(y>1 && map[(y-2)*HEIGHT + x] == 1)
			haut++;
		if(y<HEIGHT-2 && map[(y+2)*HEIGHT + x] == 1)
			bas++;
		
		if(index >= MAX || haut + bas + gauche + droite == 0)
		{
			map[HEIGHT*l + k] = 2;
			index--;
			if(index)
			{
				k = chemin[index][0];
				l = chemin[index][1];
			}
		}
		else
		{
			if(haut+bas+gauche+droite > 1)
				choix = rand()%4 + 1;
			else
				choix = haut + 4*droite + 3*bas + 2*gauche;
			
			switch(choix)
			{
				case 1:
				if(haut) l = y-2;
				break;
				
				case 2:
				if (gauche) k = x-2;
				break;
				
				case 3:
				if (bas) l = y+2;
				break;
				
				case 4:
				if(droite) k = x+2;
				break;
				
			}
			if(k != chemin[index][0] || l != chemin[index][1])
			{	
				map[HEIGHT*l + k] = 0;
				map[HEIGHT*(l + (y-l)/2) + k+(x-k)/2] = 0;
				index++;
				chemin[index][0] = k;
				chemin[index][1] = l;
				ML_pixel(k,l,0);
				ML_pixel(k+(x-k)/2 , l + (y-l)/2, 0);
				ML_display_vram();
				Sleep(10);
			}
		}
	x = k;
	y = l;
	}
	ML_clear_vram();
	
	//~ for(i=0; i< HEIGHT; i++)
	//~ {
		//~ for(j=0; j< WIDTH; j++)
		//~ {
			//~ if(map[HEIGHT*i+j] == 2)
				//~ map[HEIGHT*i+j] = 0;
			//~ ML_pixel(j, i, map[HEIGHT*i + j]);
		//~ }
	//~ }
	//~ ML_display_vram();
	
	while(KeyUp(K_EXIT));
		
		
		return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

